package com.fjhx.form.service.calculate.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.common.utils.Assert;
import com.fjhx.form.entity.calculate.dto.CalculateItemBalanceDto;
import com.fjhx.form.entity.calculate.po.CalculateItemBalance;
import com.fjhx.form.mapper.calculate.CalculateItemBalanceMapper;
import com.fjhx.form.service.calculate.CalculateItemBalanceService;
import com.ruoyi.common.exception.ServiceException;
import org.springframework.stereotype.Service;

import java.util.Date;


/**
 * <p>
 * 核算项目余额表 服务实现类
 * </p>
 *
 * @author -
 * @since 2024-05-20
 */
@Service
public class CalculateItemBalanceServiceImpl extends ServiceImpl<CalculateItemBalanceMapper, CalculateItemBalance> implements CalculateItemBalanceService {

    @DSTransactional
    @Override
    public void edit(CalculateItemBalanceDto dto) {
        String idStr = dto.getIdStr();
        Integer year = dto.getYear();

        Assert.notEmpty(dto.getYear(), "年份不能为空");
        Assert.notEmpty(dto.getIdStr(), "strId不能为空");

        if (DateUtil.year(new Date()) != dto.getYear()) {
            throw new ServiceException("禁止修改非当前年数据！");
        }

        //简称数据是否存在
        CalculateItemBalance dataBaseData = this.getOne(q -> q.eq(CalculateItemBalance::getYear, year).eq(CalculateItemBalance::getIdStr, idStr));
        if (ObjectUtil.isNotEmpty(dataBaseData)) {
            dto.setId(dataBaseData.getId());
        }

        this.saveOrUpdate(dto);
    }

}
