package com.fjhx.oa.entity.epiboly.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 外包加工账单
 * </p>
 *
 * @author
 * @since 2024-04-15
 */
@Getter
@Setter
@TableName("epiboly_bill")
public class EpibolyBill extends BasePo {

    private String code;

    private Integer status;

    /**
     * 流程id
     */
    private Long flowId;

    /**
     * 申请时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date applyTime;

    /**
     * 部门id
     */
    private Long deptId;

    /**
     * 公司id
     */
    private Long companyId;

    /**
     * 承包商
     */
    private Long contractorId;

    /**
     * 账期
     */
    private String accountPeriod;

    /**
     * 账期金额
     */
    private BigDecimal accountPeriodAmount;

    /**
     * 预付金额
     */
    private BigDecimal prepaidAmount;

    /**
     * 最终金额
     */
    private BigDecimal finalAmount;

    /**
     * 备注
     */
    private String remark;

    /**
     * 流程异常备注
     */
    private String flowAbnormalRemark;

}
